//===================================CISCKER====================================
//===================================Shifter====================================
//------------------------------------------------------------------------------
//File Name:	shifter.v
//Purpose:		Bit shifting assign statements
//Parameters:	w (width of data)
//------------------------------------------------------------------------------
//=====================Alfredo Gualdron - Jose P. Pinilla=======================
//=================================Semillero ADT================================
//================================UPB Bucaramanga===============================
//Website:	http://semilleroadt.upbbga.edu.co/xiscker
//E-mail:	semilleroadt@gmail.com
//------------------------------------------------------------------------------

module shifter #(parameter w=8)(
		//control
		input left_right, 
		input carry,
		//in
		input [w-1:0] data_in, 
		//output
		output [w:0] logic_shift,
		output [w:0] arith_shift,
		output [w:0] rotate
		);

////////////////////////////////////////////////////////////
wire [w:0] lsl = {data_in[w-1:0],1'b0};
wire [w:0] lsr = {data_in[0],1'b0,data_in[w-1:1]};

wire [w:0] asr = {data_in[0],data_in[w-1], data_in[w-1:1]};

wire [w:0] ror = {data_in[0],carry,data_in[w-1:1]};
wire [w:0] rol = {data_in[w-1:0],carry};
////////////////////////////////////////////////////////////

assign logic_shift 	= left_right ? lsr : lsl;

assign arith_shift 	= asr; //asl = lsl

assign rotate 		= left_right ? ror: rol;

endmodule
